import refreshTokenHelper from "../../../utils/refreshTokenHelper"
import getTokenHelper from "../../../utils/getTokenHelper"
import forceLogoutHelper from "../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../utils/errorHandlingHelper"
import fetchHelper from "../../../utils/fetchHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  let newObjValue = {}
  if(body.organizationId) {
    newObjValue = {...newObjValue, AD_Org_ID: {
      id: body.organizationId,
      tableName: 'AD_Org'
    }}
  }
  if(body.proxyPassword) {
    newObjValue = {...newObjValue, proxyPassword: body.proxyPassword}
  }

  const res: any = await fetchHelper(event, 'models/m_shippingprocessorcfg/'+body.id, 'PUT',token, {
    isActive: body.isActive,
    name: body.name,
    description: body.description,
    hostAddress: body.hostAddress,
    hostPort: body.hostPort,
    proxyAddress: body.proxyAddress,
    proxyLogon: body.proxyLogon,
    proxyPort: body.proxyPort,
    shippingProcessorClass: body.shippingProcessorClass,
    servicePath: body.servicePath,
    ...newObjValue,
    tableName: 'm_shippingprocessorcfg'
  })
  if(res) {
    data = res
    data['status'] = 200
    data['message'] = ''
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})